#include <stdio.h> 
#include <p18f252.h>
#include <delays.h>
#include "LCD.h"

void delay(int x)
	{
	int c;
	for(c=0;c<x;c++)
		Delay1TCY();
	}
void LCDline(char c)
	{
	char addr;
	addr = 0x80;
	if (c == 2) addr += 0x40;
	Delay10KTCYx(1);
	LCDcmd(addr);
	}

void LCDprint(char * c)
	{
	while(*c != '\0')
		{
		Delay10KTCYx(1);
		LCDdata(*c);
		c++;
		}
	}

void LCDgoto(char x,char y)
	{
	char addr;
	
	addr = 0x80 + y;
	if(x == 2) addr += 0x40;
	Delay10KTCYx(1);
	LCDcmd(addr);
	}

void LCDinit(char c)
	{
	PORTB = 0;
	TRISB = 3;
	LCDcmd(0x32);
	Delay10KTCYx(10);
	LCDcmd(0x2c);
	Delay10KTCYx(10);
	LCDcmd(0x6);
	Delay10KTCYx(10);
	LCDcmd(0xc);
	Delay10KTCYx(1);
	LCDcmd(c);
	Delay10KTCYx(1);
	}

void LCDcmd(char c)
	{
	unsigned char buf;
	buf = c & 0xf0; 
	PORTB = buf;
	Delay1KTCYx(1);
	PORTBbits.RB3 = 1;		// E
	Delay1KTCYx(1);
	PORTBbits.RB3 = 0;		// E
	buf = (c << 4) & 0xf0; 
	PORTB = buf;
	Delay1KTCYx(1);
	PORTBbits.RB3=1;		// E
	Delay1KTCYx(1);
	PORTBbits.RB3 = 0;		// E
	}

void LCDdata(char c)
	{
	unsigned char buf;
	buf = c & 0xf0; 
	PORTB = buf;
	PORTBbits.RB2 = 1;		// R/S
	Delay1KTCYx(1);
	PORTBbits.RB3 = 1;		// E
	Delay1KTCYx(1);
	PORTBbits.RB3 = 0;		// E
	buf = (c << 4) & 0xf0; 
	PORTB = buf;
	PORTBbits.RB2 = 1;		// R/S
	Delay1KTCYx(1);
	PORTBbits.RB3=1;		// E
	Delay1KTCYx(1);
	PORTBbits.RB3 = 0;		// E
	}