#include <stdio.h> 
#include <p18f4520.h>
#include <delays.h>
#include "LCD.h"

void delay(int x)
	{
	int c;
	for(c=4;c<x;c++)
		Delay1TCY();
	}
void LCDline(char c)
	{
	char addr;
	addr = 0x80;
	if (c == 2) addr += 0x40;
	while(LCDbusy());
	LCDcmd(addr);
	}

void LCDprint(char * c)
	{
	while(*c != '\0')
		{
		while(LCDbusy());
		LCDdata(*c);
		c++;
		}
	}

void LCDgoto(char x,char y)
	{
	char addr;
	
	addr = 0x80 + x;
	if(y == 2) addr += 0x40;
	while(LCDbusy());
	LCDcmd(addr);
	}

void LCDinit(char c)
	{
	PORTD = 0;
	PORTE = 0;
	TRISD = 0;
	TRISE = 0;
	LCDcmd(0x33);
	Delay10KTCYx(33);
	LCDcmd(0x33);
	Delay10KTCYx(33);
	LCDcmd(0x38);
	Delay10KTCYx(38);
	LCDcmd(0xC);
	Delay10KTCYx(40);
	LCDcmd(0x6);
	Delay10KTCYx(10);
	LCDcmd(c);
	Delay1KTCYx(1);
	}

char LCDbusy()
	{
	char busy;
	busy = 0;
	PORTD = 0;
	TRISD = 255;
	PORTE = 0;
	PORTE = 2;		// R/W
	delay(18);
	PORTE = 6;		// E
	delay(18);
	if(PORTD & 0x80) busy = 1;
	PORTE = 2;

	PORTE = 0;
	TRISD = 0;
	
		
	return busy;
	}

void LCDcmd(char c)
	{
	PORTE = 0;		// R/S
	PORTD = c;
	Delay1KTCYx(1);
	PORTE = 4;		// E
	Delay1KTCYx(1);
	PORTE = 0;		// E
	}

void LCDdata(char c)
	{
	PORTE = 1;		// R/S
	PORTD = c;
	Delay1KTCYx(1);
	PORTE = 5;		// E
	Delay1KTCYx(1);
	PORTE = 1;
	Delay1KTCYx(1);
	PORTE = 0;		// E
	}